SystemOrganization addCategory: #ProyectoFinal!

Object subclass: #Issuer
	instanceVariableNames: 'name lastName address DNI CUIT'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProyectoFinal'!

!Issuer class methodsFor: 'class initialization' stamp: 'PauloPerez 7/16/2012 20:25'!
name: aName lastName: aLastName DNI: aDNI CUIT: aCUIT address: anAddress
	^ (self new)
		name: aName
			lastName: aLastName
			DNI: aDNI
			CUIT: aCUIT
			address: anAddress;
		yourself! !

!Issuer methodsFor: 'accessing' stamp: 'PauloPerez 7/16/2012 20:24'!
name: aName lastName: aLastName DNI: aDNI CUIT: aCUIT address: anAddress
	name := aName.
	lastName := aLastName.
	DNI := aDNI.
	CUIT := aCUIT.
	address := anAddress! !

Object subclass: #Order
	instanceVariableNames: 'quantity price date issuer unitPrice'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProyectoFinal'!

!Order class methodsFor: 'class initialization' stamp: 'PauloPerez 7/16/2012 19:01'!
ask: quantity price: amount
	^ SalesOrder ask: quantity price: amount! !

!Order class methodsFor: 'class initialization' stamp: 'PauloPerez 7/16/2012 19:01'!
bid: quantity price: amount
	^ PurchaseOrder bid: quantity price: amount! !

!Order methodsFor: 'private' stamp: 'PauloPerez 7/16/2012 19:40'!
computeUnitPrice
	unitPrice := price / quantity! !

!Order methodsFor: 'accessing' stamp: 'PauloPerez 7/16/2012 19:41'!
quantity: aQuantity price: amount
	quantity := aQuantity.
	price := amount.
	self computeUnitPrice! !

!Order methodsFor: 'accessing' stamp: 'PauloPerez 7/16/2012 19:48'!
quantity: aQuantity price: amount date: aDate issuer: anIssuer
	self quantity: aQuantity price: amount.
	date := aDate.
	issuer := anIssuer! !

Order subclass: #PurchaseOrder
	instanceVariableNames: 'receivingAddress shippingMethod'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProyectoFinal'!

!PurchaseOrder class methodsFor: 'class initialization' stamp: 'PauloPerez 7/13/2012 18:46'!
ask: quantity price: amount
	^ self shouldNotImplement! !

!PurchaseOrder class methodsFor: 'class initialization' stamp: 'PauloPerez 7/16/2012 14:31'!
bid: quantity price: amount
	^ (self new)
		quantity: quantity price: amount;
		yourself! !

!PurchaseOrder class methodsFor: 'class initialization' stamp: 'PauloPerez 7/16/2012 20:47'!
bid: quantity price: amount date: aDate issuer: anIssuer receivingAddress: aReceivingAddress shippingMethod: aShippingMethod
	^ (self new)
		bid: quantity
			price: amount
			date: aDate
			issuer: anIssuer
			receivingAddress: aReceivingAddress
			shippingMethod: aShippingMethod;
		yourself! !

!PurchaseOrder methodsFor: 'accessing' stamp: 'PauloPerez 7/16/2012 20:49'!
bid: aQuantity price: amount date: aDate issuer: anIssuer receivingAddress: aReceivingAddress shippingMethod: aShippingMethod
	self
		quantity: aQuantity
		price: amount
		date: aDate
		issuer: anIssuer.
	receivingAddress := aReceivingAddress.
	shippingMethod := aShippingMethod! !

Order subclass: #SalesOrder
	instanceVariableNames: 'paymentMethod availabilityDate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProyectoFinal'!

!SalesOrder class methodsFor: 'class initialization' stamp: 'PauloPerez 7/16/2012 14:31'!
ask: quantity price: amount
	^ (self new)
		quantity: quantity price: amount;
		yourself! !

!SalesOrder class methodsFor: 'class initialization' stamp: 'PauloPerez 7/16/2012 20:52'!
ask: quantity price: amount date: aDate issuer: anIssuer paymentMethod: aPaymentMethod availabilityDate: anAvailabilityDate
	^ (self new)
		ask: quantity
			price: amount
			date: aDate
			issuer: anIssuer
			paymentMethod: aPaymentMethod
			availabilityDate: anAvailabilityDate;
		yourself! !

!SalesOrder class methodsFor: 'class initialization' stamp: 'PauloPerez 7/13/2012 18:47'!
bid: quantity price: amount
	^ self shouldNotImplement! !

!SalesOrder methodsFor: 'accessing' stamp: 'PauloPerez 7/16/2012 20:53'!
ask: aQuantity price: amount date: aDate issuer: anIssuer paymentMethod: aPaymentMethod availabilityDate: anAvailabilityDate
	self
		quantity: aQuantity
		price: amount
		date: aDate
		issuer: anIssuer.
	paymentMethod := aPaymentMethod.
	availabilityDate := anAvailabilityDate! !

Object subclass: #OrderBook
	instanceVariableNames: 'purchaseOrders salesOrders marketPrice'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProyectoFinal'!

!OrderBook methodsFor: 'as yet unclassified' stamp: 'PauloPerez 7/16/2012 20:56'!
addOrder: anOrder
	"Agrega una orden al arreglo de ordenes dependiendo de su tipo"

	(anOrder isMemberOf: PurchaseOrder)
		ifTrue: [ purchaseOrders add: anOrder ].
	(anOrder isMemberOf: SalesOrder)
		ifTrue: [ salesOrders add: anOrder ]! !

!OrderBook methodsFor: 'initialize-release' stamp: 'PauloPerez 7/16/2012 20:56'!
initialize
	purchaseOrders := OrderedCollection new.
	salesOrders := OrderedCollection new! !

!OrderBook methodsFor: 'as yet unclassified' stamp: 'PauloPerez 7/16/2012 20:57'!
marketPrice
	"El Precio de Mercado es el precio nico por unidad al cual se comercializarn el producto en la etapa de Trading"

	| temporary variable names |
	^ marketPrice! !

!OrderBook methodsFor: 'as yet unclassified' stamp: 'OLSA 7/17/2012 13:08'!
totalOrders
	"comment stating purpose of message"

	^ purchaseOrders  size + salesOrders  size! !

!OrderBook methodsFor: 'as yet unclassified' stamp: 'DiegoValdeblanquez 7/17/2012 11:30'!
tradingTickets
	"Durante esta etapa se realizan las transacciones de compra-venta del producto correspondiente al OrderBook, siempre al precio fijo establecido por el Precio de Mercado en la etapa anterior"

	| tradingTickets ordenVenta ordenCompra |
	tradingTickets := OrderedCollection new.
	tradingTickets
		add:
			(TradingTicket
				purchaseOrder: ordenCompra
				salesOrder: ordenVenta
				marketPrice: marketPrice
				transactionDate: Date today).
	^ tradingTickets! !

Object subclass: #PEM
	instanceVariableNames: 'tradingTickets orderBook issuers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProyectoFinal'!

!PEM methodsFor: 'as yet unclassified' stamp: 'PauloPerez 7/16/2012 20:59'!
addEmisor: anEmisor
	"Agrega un empleado al arreglo de empleados"

	anEmisor isNil
		ifFalse: [ issuers add: anEmisor ]! !

!PEM methodsFor: 'as yet unclassified' stamp: 'OLSA 7/17/2012 13:02'!
emisores

	| emisores |
	^ emisores! !

!PEM methodsFor: 'initialize-release' stamp: 'PauloPerez 7/16/2012 20:59'!
initialize
	tradingTickets := OrderedCollection new.
	issuers := OrderedCollection new.
	orderBook := OrderBook new! !

!PEM methodsFor: 'as yet unclassified' stamp: 'OLSA 7/17/2012 13:03'!
issuers 
	
	^ issuers ! !

!PEM methodsFor: 'as yet unclassified' stamp: 'PauloPerez 7/13/2012 18:13'!
marketPrice
"El Precio de Mercado es el precio nico por unidad al cual se comercializarn los productos en la etapa de trading"
	^ orderBook marketPrice! !

!PEM methodsFor: 'as yet unclassified' stamp: 'PauloPerez 7/16/2012 21:16'!
receiveOrder: anOrder
	"Agrega una orden al orderBook"

	anOrder isNil
		ifFalse: [ orderBook addOrder: anOrder ]! !

!PEM methodsFor: 'as yet unclassified' stamp: 'OLSA 7/17/2012 15:04'!
totalOrders
	"comment stating purpose of message"

	^orderBook totalOrders ! !

!PEM methodsFor: 'as yet unclassified' stamp: 'PauloPerez 7/13/2012 18:11'!
tradingTickets
	"Durante esta etapa se realizan las transacciones de compra-venta de productos, siempre al precio fijo establecido por el Precio de Mercado en la etapa anterior"

	^ orderBook tradingTickets! !

Object subclass: #TradingTicket
	instanceVariableNames: 'marketPrice transactionDate purchaseOrder salesOrder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProyectoFinal'!

!TradingTicket class methodsFor: 'class initialization' stamp: 'PauloPerez 7/16/2012 21:27'!
purchaseOrder: aPurchaseOrder salesOrder: aSalesOrder marketPrice: aMarketPrice transactionDate: aTransactionDate
	^ (self new)
		purchaseOrder: aPurchaseOrder
			salesOrder: aSalesOrder
			marketPrice: aMarketPrice
			transactionDate: aTransactionDate;
		yourself! !

!TradingTicket methodsFor: 'printing' stamp: 'PauloPerez 7/16/2012 21:00'!
printOn: aStream
	aStream
		nextPutAll: 'Orden de compra ';
		print: purchaseOrder;
		space;
		space;
		nextPutAll: 'Orden de venta ';
		print: salesOrder;
		space;
		space;
		nextPutAll: 'Precio mercado ';
		print: marketPrice;
		cr;
		nextPutAll: 'Fecha transaccin ';
		print: transactionDate;
		cr.
	aStream cr! !

!TradingTicket methodsFor: 'accessing' stamp: 'PauloPerez 7/16/2012 21:28'!
purchaseOrder: aPurchaseOrder salesOrder: aSalesOrder marketPrice: aMarketPrice transactionDate: aTransactionDate
	"Mensaje que escribe en cada TradingTicket los datos de las ordenes de compra y venta que se puedieron efectivizar a un cierto precio de mercado calculado y definido en una fecha determinada."

	purchaseOrder := aPurchaseOrder.
	salesOrder := aSalesOrder.
	marketPrice := aMarketPrice.
	transactionDate := aTransactionDate! !
